;------------------------------------------------------------------------------
; Time handling routines.              (c) 1991 Software R&D Lab., Sofia by YGP

interpreter     =       $befe

                section $b0
wrkA            ds      2
wrkB            ds      2
wrkX            ds      2
wrk_24          ds      4
                ends; $80

;------------------------------------------------------------------------------
; procedure add_time(t1, t2: time; var interval: time; var carry: byte);
;                    10..13 6..9             4, 5             2, 3

add_time        proc
                dw      0
                tsx
                lda     x, 10           ; s100
                adda    x, 6            ; + s100
                clrb
                cmpa    #100
                bcs     OK_s100
                subA    #100
                incB
OK_s100         pha
                addb    x, 11           ; carry + s
                addb    x, 7            ; + s
                clra
                cmpb    #60
                bcs     OK_s
                subB    #60
                incA
OK_s            phb
                adda    x, 12           ; carry + m
                adda    x, 8            ; + m
                clrb
                cmpa    #60
                bcs     OK_m
                subA    #60
                incB
OK_m            pha
                addb    x, 13           ; carry + h
                addb    x, 9            ; + h
                clra
                cmpB    #24
                bcs     OK_h
                subB    #24
                incA
OK_h
common_AS       =       *
                phb
                ldx     x, 2            ; clear carry parameter
                stb     x, 0
                clr     x, 1
                lda     #14
                tsx
                ldx     x, 4+4          ; result's address
setT_pop_A_jmp  =       *
                plb
                stb     x, 3
                plb
                stb     x, 2
                plb
                stb     x, 1
                plb
                stb     x, 0
pop_A_jmp       =       *
pop_loop        ins
                decA
                bne     pop_loop
                jmp     interpreter
                endp; add_time

;------------------------------------------------------------------------------
; procedure sub_time(t1, t2: time; var interval: time; var carry: byte);
;                    10..13 6..9             4, 5             2, 3

sub_time        proc
                dw      0
                tsx
                clrb
                lda     x, 10           ; s100
                suba    x, 6            ; - s100
                bpl     OK_s100
                addA    #100
                decB
OK_s100         pha
                clra
                addb    x, 11           ; carry + s
                subb    x, 7            ; - s
                bpl     OK_s
                addB    #60
                decA
OK_s            phb
                clrb
                adda    x, 12           ; carry + m
                suba    x, 8            ; - m
                bpl     OK_m
                addA    #60
                decB
OK_m            pha
                clra
                addb    x, 13           ; carry + h
                subb    x, 9            ; - h
                bpl     common_AS
                addb    #24
                incA                    ;   inc
                bra     common_AS
                endp; sub_time

;------------------------------------------------------------------------------
; procedure fetch_time(var t: time);

fetch_ti        proc
                dw      0
                int     $1c             ; get time
                stx     wrkX
                tsx
                ldx     x, 2
                stb     x, 3
                sta     x, 2
                lda     wrkX+1
                ldb     wrkX
                stb     x, 1
                sta     x, 0
                lda     #4
pop_A_jmp_n     =       *
                bra     pop_A_jmp
                endp; fetch_ti

;------------------------------------------------------------------------------
; procedure time2str(t: time; var s: string[11]);

time2str        proc
                dw      0
                ins
                ins
                tsx
                ldx     x, 0
                ins
                ins
                lda     #11
                sta     x, 0
                lda     #':'
                sta     x, 3
                sta     x, 6
                lda     #'.'
                sta     x, 9
                ldb     #4

loop            pla
                phb
                clrb
sub_loop        incB
                subA    #10
                bpl     sub_loop
                addb    #'0' -1
                adda    #'0' +10
                sta     x, 11
                stb     x, 10
                dex
                dex
                dex
                plb
                decB
                bne     loop
                jmp     interpreter
                endp; time2str

;------------------------------------------------------------------------------

                public  add_time
                public  sub_time
                public  fetch_ti;me
                public  time2str
;
;;------------------------------------------------------------------------------
;; procedure Time_Div_N(t: time; N: cardinal; var result: time);
;
;time_div        proc
;                dw      0
;                bsr     clear_res       ; result := 0;
;                tsx                     ; convert time to long word
;                lda     x, 9            ; hour
;                ldb     #60
;                bsr     add_mul         ; result:= (result + hour)* 60
;                lda     x, 8            ; min
;                bsr     add_mul         ; result:= (result + min) * 60
;                lda     x, 7            ; sec
;                ldb     #100
;                bsr     add_mul         ; result:= (result + sec) *100
;                lda     x, 6
;                bsr     add_24x8        ; wrk_24 = (((h*60)+m)*60+s)*100+s100
;
;                lda     #10
;                bra     pop_A_jmp_n
;                endp; time_div
;
;clear_res       proc ;---------------------------------------------------------
;                ldx     #0
;                stx     wrk_24
;                stx     wrk_24+2
;                rts
;                endp; clear_res
;
;add_24x8        proc ;---------------------------------------------------------
;                adda    wrk_24+3  ; calculates wrk_24 := A + wrk_24
;                sta     wrk_24+3
;                bcc     rts
;                inc     wrk_24+2
;                bne     rts
;                inc     wrk_24+1
;rts             rts
;                endp; add_mul
;
;
;add_mul         proc ;---------------------------------------------------------
;                phb
;                bsr     add_24x8
;                pla
;                bra     mul_24x8        ; bsr + rts (  )
;                endp; add_mul
;
;mul_24x8        proc ;---------------------------------------------------------
;                     ; wrk24 := wrk_24 * A
;
;                stx     wrkX            ; preserve X
;                sta     wrkS+1          ; op1
;                stb     wrkB            ; op2
;                clra                    ; result:= 0;
;                clrb
;                sta     wrkS
;                ldx     #8              ; cnt:= 8;
;loop                                    ; repeat
;                lsr     wrkB            ;   op2:= op2 shr 1;
;                bcc     DontAdd         ;   if HasCarry
;                adda    wrkS+1          ;     then Inc(result, op1);
;                adcb    wrkS
;DontAdd         asl     wrkS+1          ;   op1:= op1 shl 1;
;                rol     wrkS
;                dex                     ;   Dec(cnt);
;                bne     loop            ; until cnt = 0;
;                ldx     wrkX            ; restoreX
;                rts
;                endp; mul_24x8
;
;time_2_long     proc ;---------------------------------------------------------
;                     ; X - time address, A - time offset
;
;
;                endp; time_2_long