{ UniTime for Turbo Pascal }
unit UniTime; interface
  {$I UniTime.int }
implementation
  uses DOS;

  procedure fetch_time(var t: time);
    var _h, _m, _s, _s100: word;
  begin
    gettime(_h, _m, _s, _s100);
    with t do begin
      h:= _h; m:= _m; s:= _s; s100:= _s100;
    end { with };
  end { fetch_time };

  procedure add_time(t, interval: time; var result: time; var day: word);
  begin
    inc(t.s100, interval.s100);
    if 100 <= byte(t.s100) then begin
      dec(t.s100, 100); inc(t.s);
    end { if };

    inc(t.s, interval.s);
    if 60 <= byte(t.s) then begin
      dec(t.s, 60); inc(t.m);
    end { if };

    inc(t.m, interval.m);
    if 60 <= byte(t.m) then begin
      dec(t.m, 60); inc(t.h);
    end { if };

    inc(t.h, interval.h);
    day:= ord(24 <= byte(t.h));
    if odd(day) then begin
      dec(t.h, 24);
    end { if };
    result:= t;
  end { add_time };

  procedure sub_time(t1, t2: time; var interval: time; var day: word);
  begin                     {   Turbo Pascal     shortint }
    dec(t1.s100, t2.s100);
    if t1.s100 < 0 then begin
      inc(t1.s100, 100); dec(t1.s);
    end { if };

    dec(t1.s, t2.s);
    if t1.s < 0 then begin
      inc(t1.s, 60); dec(t1.m);
    end { if };

    dec(t1.m, t2.m);
    if t1.m < 0 then begin
      inc(t1.m, 60); dec(t1.h);
    end { if };

    dec(t1.h, t2.h);
    day:= ord(t1.h < 0);
    if odd(day) then begin
      inc(t1.h, 24);
    end { if };
    interval:= t1;
  end { sub_time };

  procedure time2str(t: time; var s: string(*)[11](*));
  begin
    s:= '00:00:00.00';
    s[ 1]:= chr(ord('0') +t.h div 10);    s[ 2]:= chr(ord('0') +t.h mod 10);
    s[ 4]:= chr(ord('0') +t.m div 10);    s[ 5]:= chr(ord('0') +t.m mod 10);
    s[ 7]:= chr(ord('0') +t.s div 10);    s[ 8]:= chr(ord('0') +t.s mod 10);
    s[10]:= chr(ord('0') +t.s100 div 10); s[11]:= chr(ord('0') +t.s100 mod 10);
  end { time2str };

  procedure div_time(t:time; N:word; var res:time; var m:word);
    var l: longint;
  begin
    if N = 0 then
      make_time(0, 0, 0, 0, res, m)
    else begin
      with t do begin
        l:= (((longint(h)*60 + m)*60 + s)*100 + s100);
        m:= l mod n; l:= l div n;
        s100:= l mod 100; l:= l div 100;
        s:= l mod 60; l:= l div 60;
        m:= l mod 60; h:= l div 60;
      end { with };
      res:= t;
    end { if }
  end { div_time };

  procedure mul_time(t: time; N: word; var res: time; var day: word);
    var _s100, _s, _m, _h: word;
  begin
    with t do begin
      _s100:= s100 * n;
      _s:= s * n;
      _m:= m * n;
      _h:= h * n;
    end { with };
    make_time(_h, _m, _s, _s100, res, day);
  end { Time_Div_N };

  procedure make_time(h,m,s,s100:word; var t:time; var day:word);
  begin
    if 100 <= s100 then begin
      inc(s, s100 div 100); s100:= s100 mod 100;
    end { if };

    if 60 <= s then begin
      inc(m, s div 60); s:= s mod 60;
    end { if };

    if 60 <= m then begin
      inc(h, m div 60); m:= m mod 60;
    end { if };

    day:= h div 24; h:= h mod 24;

    t.h:= h; t.m:= m; t.s:= s; t.s100:= s100;
  end { make_time };

  function time2long(t: time): longint;
  begin { time2long }
    with t do time2long:= (((h*60 + m)*60 + s)*100 + s100);
  end { time2long };

  procedure long2time(l: longint; var t: time; var day: word);
  begin { long2time }
    with t do begin
      s100:= l mod 100; l:= l div 100;
      s:= l mod 60; l:= l div 60;
      m:= l mod 60; l:= l div 60;
      h:= l mod 24; day:= l div 24;
    end { with };
  end { long2time };

end { UniTime }.